# ThemeProvider

Usually an application will be wrapped inside a ThemeProvider to allow it to switch between different themes.

Components inside the ThemeProvider can get (and update) the theme using the useTheme hook.

```tsx
import { FC } from 'React';
import ThemeProvider from '@ucam/design-system/theme/ThemeProvider';

const App: FC = () => (
  <ThemeProvider>
    <div>{'Some text in the style of the current theme'}</div>
  </ThemeProvider>
);
```

```tsx live=true
import { FC } from 'React';
import ThemeProvider from '@ucam/design-system/theme/ThemeProvider';
import useTheme from '@ucam/design-system/theme/useTheme';
import { P } from '@ucam/design-system/Typography';

const ThemeNameReader: FC = () => {
  const { renderedThemeName } = useTheme();
  return <P>The theme inside this ThemeProvider is: {renderedThemeName}</P>;
};

render(
  <ThemeProvider defaultThemeName="Dark" disableLocalStorage scope="local">
    <ThemeNameReader />
  </ThemeProvider>
);
```

ThemeProviders can also be nested:

```tsx live=true
import { FC } from 'React';
import ThemeProvider from '@ucam/design-system/theme/ThemeProvider';
import useTheme from '@ucam/design-system/theme/useTheme';
import { P } from '@ucam/design-system/Typography';

const ThemeNameReader: FC = () => {
  const { renderedThemeName } = useTheme();
  return <P>The theme inside this ThemeProvider is: {renderedThemeName}</P>;
};

render(
  <ThemeProvider defaultThemeName="Dark" disableLocalStorage scope="local">
    <ThemeNameReader />
    <ThemeProvider defaultThemeName="Light" disableLocalStorage scope="local">
      <ThemeNameReader />
      <ThemeProvider defaultThemeName="Dark" disableLocalStorage scope="local">
        <ThemeNameReader />
      </ThemeProvider>
    </ThemeProvider>
  </ThemeProvider>
);
```

[//]: # 'property-table-DO-NOT-EDIT'
[//]: # 'property-table-DO-NOT-EDIT'
